# ConcreteStructs.jl
![](assets/ConcreteStructs_logo.png)

| **Documentation**                                                               | **Build Status**                                                                                |
|:-------------------------------------------------------------------------------:|:-----------------------------------------------------------------------------------------------:|
| [![][docs-stable-img]][docs-stable-url] [![][docs-dev-img]][docs-dev-url] | [![][github-img]][github-url] [![][codecov-img]][codecov-url] |


[docs-dev-img]: https://img.shields.io/badge/docs-latest-blue.svg
[docs-dev-url]: https://SciML.github.io/ConcreteStructs.jl/dev

[docs-stable-img]: https://img.shields.io/badge/docs-stable-blue.svg
[docs-stable-url]: https://SciML.github.io/ConcreteStructs.jl/stable

[github-img]: https://img.shields.io/github/workflow/status/SciML/ConcreteStructs.jl/CI
[github-url]: https://github.com/SciML/ConcreteStructs.jl/actions/workflows/CI

[codecov-img]: https://img.shields.io/codecov/c/github/SciML/ConcreteStructs.jl
[codecov-url]: https://codecov.io/gh/SciML/ConcreteStructs.jl


ConcreteStructs.jl exports the macro `@concrete`, which can be used to make non-concrete structs
concrete without the boilerplate of adding type parameters.

```julia
using ConcreteStructs

@concrete struct AB
    a
    b
end
```
```julia-repl
julia> ab = AB("hi", 1+im)
AB{String,Complex{Int64}}("hi", 1 + 1im)
```
 The macro also supports the `terse` keyword to allow the types to show without their parameters while in `:compact => true` mode of an `IOContext`.
```julia
@concrete terse mutable struct CDE{D} <: Number
    d::D
    c
    e::Symbol
end
```
```julia-repl
julia> cde = CDE(1f0, (1,2.0), :yo)
CDE(1.0f0, (1, 2.0), :yo)

julia> typeof(cde)
CDE{Float32,Tuple{Int64,Float64}}
```
Types with more complicated parameterizations are also handled
```julia
@concrete terse struct FGH{T,N,G<:AbstractArray{T,N}} <: AbstractArray{T,N}
    g::G
    h::T
    f
    function FGH(g::AbstractArray{T,N}, h::H, f) where {T,N,H}
        Tnew = promote_type(T, H)
        g, h = Tnew.(g), Tnew(h)
        return new{Tnew,N,typeof(g),typeof(f)}(g, h, f)
    end
end

Base.size(x::FGH) = size(x.g)

Base.getindex(x::FGH, i...) = getindex(x.g[i...])
```
```julia-repl
julia> fgh = FGH([1,2,3], 4, nothing)
3-element FGH:
 1
 2
 3

julia> typeof(fgh)
FGH{Int64,1,Array{Int64,1},Nothing}
```

## Attributions
<div>Icon modified from <a href="https://www.flaticon.com/free-icon/building_2139469?term=concrete+building&related_id=2139469&origin=search">Building icon</a> made by <a href="https://www.flaticon.com/authors/skyclick" title="Skyclick">Skyclick</a> from <a href="https://www.flaticon.com/" title="Flaticon">www.flaticon.com</a></div>

"""
    ConcreteStructs

ConcreteStructs exports the macro `@concrete`, which can be used to concretely parameterize
structs.
"""
module ConcreteStructs


export @concrete


"""
    @concrete struct
    @concrete mutable struct
    @concrete terse struct
    @concrete terse mutable struct

The `@concrete` macro makes non-concrete structs concrete, saving the boilerplate of making
type parameters. The `terse` keyword causes the types to show without their parameters while
in `:compact => true` mode of an `IOContext`.

## Examples
```jldoctest
julia> using ConcreteStructs

julia> @concrete struct AB
           a
           b
       end

julia> ab = AB("hi", 1 + im)
AB{String, Complex{Int64}}("hi", 1 + 1im)

julia> @concrete terse mutable struct CDE{D} <: Number
           d::D
           c
           e::Symbol
       end

julia> cde = CDE(1.0f0, (1, 2.0), :yo)
CDE{Float32}(1.0f0, (1, 2.0), :yo)

julia> typeof(cde)
CDE{Float32,Tuple{Int64, Float64}}

julia> @concrete terse struct FGH{T, N, G <: AbstractArray{T, N}} <: AbstractArray{T, N}
           f
           g::G
           h::T
       end

julia> Base.size(x::FGH) = size(x.g);

julia> Base.getindex(x::FGH, i...) = getindex(x.g[i...]);

julia> fgh = FGH(nothing, [1, 2, 3], 4)
3-element FGH{Int64,1,Vector{Int64}}:
 1
 2
 3

julia> typeof(fgh)
FGH{Int64,1,Vector{Int64},Nothing}
```
"""
macro concrete(expr)
    expr, _, _ = _concretize(expr)
    return esc(expr)
end

macro concrete(terse, expr)
    terse isa Symbol && terse == :terse || error("Invalid usage of @concrete")

    expr, struct_name, type_params = _concretize(expr)
    struct_name = string(struct_name)
    num_params = length(type_params)

    terse_string = if num_params == 0
        struct_name
    else
        :($(struct_name) * "{" * join(T.parameters[1:$num_params], ",") * "}")
    end

    return quote
        $(Base).@__doc__ $expr
        function Base.show(io::IO, T::Type{<:$(Symbol(struct_name))})
            return if T isa UnionAll
                print(io, $struct_name)
            else
                print(io, $(struct_name) * "{" * join(T.parameters[1:$num_params], ",") * "}")
            end
        end
        function Base.show(io::IO, ::MIME"text/plain", T::Type{<:$(Symbol(struct_name))})
            if T isa UnionAll
                return print(io, $struct_name)
            else
                return print(io, $(struct_name) * "{" * join(T.parameters, ",") * "}")
            end
        end
    end |> esc
end


# Parse whole struct definition for the @concrete macro
function _concretize(expr)
    original_expr, expr = _find_struct_def(expr)

    is_mutable = expr.args[1]
    struct_name, type_params, super = _parse_head(expr.args[2])
    line_tuples = _parse_line.(expr.args[3].args)
    lines = first.(line_tuples)
    type_params_full = (type_params..., filter(x -> x !== nothing, last.(line_tuples))...)

    struct_type = if length(type_params_full) == 0
        struct_name
    else
        Expr(:curly, struct_name, type_params_full...)
    end

    head = Expr(:(<:), struct_type, super)
    constructor_expr = _make_constructor(struct_name, type_params, type_params_full, lines)
    body = Expr(:block, lines..., constructor_expr)
    struct_expr = Expr(:struct, is_mutable, head, body)

    struct_expr = _apply_original_expr(original_expr, struct_expr)

    return struct_expr, struct_name, type_params
end


# Make the inner constructor function
function _make_constructor(struct_name, type_params, type_params_full, lines)
    lines = map(line -> line isa Expr && line.head == :(=) ? line.args[1] : line, lines)
    field_lines = filter(line -> ((line isa Expr) && (line.head === :(::))), lines)
    args = map(x -> x.args, field_lines)
    vars = first.(args)
    var_types = last.(args)
    constructor_params = _get_constructor_params(type_params, var_types)
    new_params = _strip_super(type_params_full)

    if length(type_params) == length(type_params_full) && all(type_params .== type_params_full)
        return Expr(:block)
    elseif length(constructor_params) == 0
        return :(
            function $struct_name($(field_lines...)) where {$(type_params_full...)}
                return new{$(new_params...)}($(vars...))
            end
        )
    else
        return :(
            function $struct_name{$(constructor_params...)}($(field_lines...)) where {$(type_params_full...)}
                return new{$(new_params...)}($(vars...))
            end
        )
    end
end


# Get the parameters that are unmatched to variables and need to be annotated in the constructor
function _get_constructor_params(type_params, var_types)
    subparams = _get_subparams(type_params)
    type_params = _strip_super(type_params)
    var_types = [subparams; _strip_super(var_types)]
    return setdiff(type_params, var_types)
end


# Strip supertype annotations
_strip_super(x) = x
_strip_super(x::Union{Tuple, AbstractVector}) = vcat(_strip_super.(x)...)
_strip_super(x::Expr) = x.head == :(<:) ? x.args[1] : x


# Get the subparameters of supertypes of subtype parameters (sorry)
_get_subparams(x) = []
_get_subparams(x::Union{Tuple, AbstractVector}) = vcat(_get_subparams.(x)...)
function _get_subparams(x::Expr)
    if x.head === :curly
        return x.args[2:end]
    elseif x.head === :(<:)
        return _get_subparams(x.args[2:end])
    end
end


# Parse the top line of the struct definition
_parse_head(head::Symbol) = (_parse_struct_def(head)..., :(Any))
function _parse_head(head::Expr)
    if head.head === :curly
        super = :(Any)
        struct_name, type_params = _parse_struct_def(head)
    elseif head.head === :(<:)
        super = head.args[2]
        struct_name, type_params = _parse_head(head.args[1])
    else
        error("Invalid usage of @concrete.")
    end

    return (struct_name, type_params, super)
end


# Parse the struct name and parameters
_parse_struct_def(struct_def::Symbol) = (struct_def, [])
_parse_struct_def(struct_def::Expr) = (struct_def.args[1], struct_def.args[2:end])


# Parse a line of the body of the struct def. Returns the line and the type parameter to be
# included in the struct header
_parse_line(line) = (line, nothing)
function _parse_line(line::Expr)
    assignment = line.head === :(=)
    annotation = nothing
    val = nothing
    if assignment
        val = line.args[2]
        line, annotation = _parse_line(line.args[1])
    end

    out = if line isa Expr && line.head === :(<:)
        field = line.args[1]
        T = line.args[2]
        sym = Symbol(:__T_, field)
        (:($field::$sym), :($sym <: $T))
    else
        (line, annotation)
    end

    return if assignment
        (:($(out[1]) = $val), out[2])
    else
        out
    end


    # if (T isa Symbol && isdefined(Base.Main, T) && !isconcretetype(Base.eval(Base.Main, T))) || T isa Expr
    #     sym = Symbol("__T_" * string(field))
    #     return (:($field::$sym), :($sym<:$T))
    # else
    #     return (line, nothing)
    # end
end
function _parse_line(line::Symbol)
    T = Symbol("__T_" * string(line))
    return (:($line::$T), T)
end

# find the struct def in case its encapsuled in other macros
# returns full_original_expression, struct_definition_expr
function _find_struct_def(expr; tl_expr = expr)
    if expr.head == :struct
        return tl_expr, expr
    elseif expr.head == :macrocall
        return _find_struct_def(expr.args[3]; tl_expr = tl_expr)
    end
    return error("Invalid usage of @concrete.")
end

# finds where the struct is defined in original_expr and plugs in struct_expr
function _apply_original_expr(original_expr, struct_expr)
    if original_expr.head == :struct
        original_expr.args = struct_expr.args
    elseif original_expr.head == :macrocall
        original_expr.args[3] = _apply_original_expr(original_expr.args[3], struct_expr)
    else
        error("Unsupported expression.")
    end
    return original_expr
end

end

using ConcreteStructs
using ConcreteStructs: _parse_head, _parse_struct_def, _parse_line
using ConcreteStructs: _strip_super, _get_subparams, _get_constructor_params
using LinearAlgebra: Adjoint
using Suppressor
using Test


# # Unit Tests

# Test setup
line_number_node = LineNumberNode(1)
annotated_abstract = :(b::AbstractFloat)
annotated_concrete = :(b::Float64)
struct_name = :(MyStruct)
sub_typed_params = :(MyStruct{T1,T2<:AbstractVector{T1}})
sub_typed = :(MyStruct{D} <: Number)
kitchen_sink = :(MyStruct{T1, T2<:AbstractVector{T1}} <: AbstractVector{T1})
plain_assignment = :(a=1)
annotated_assignment = :(a::Float64=2.0)
subtype_annotated_assignment = :(a<:Real=2.0)


# Run tests
@testset "Unit tests" begin
    @testset "_parse_line" begin
        @test _parse_line(line_number_node) == (line_number_node, nothing)
        # @test _parse_line(annotated_abstract)[1].args[2] != :AbstractFloat
        # @test _parse_line(annotated_abstract)[2].args[2] == :AbstractFloat
        @test _parse_line(annotated_concrete)[1].args[2] == :Float64
        @test _parse_line(annotated_concrete)[2] === nothing

        parsed_sym = _parse_line(:a)
        @test parsed_sym[1].args[2] == parsed_sym[2]

        @test _parse_line(plain_assignment)[1].head == :(=)
        @test _parse_line(plain_assignment)[1].args[1].args[2] == _parse_line(plain_assignment)[2]
        @test _parse_line(annotated_assignment)[1].head == :(=)
        @test _parse_line(annotated_assignment)[2] === nothing
        @test _parse_line(subtype_annotated_assignment)[1].head == :(=)
        @test _parse_line(subtype_annotated_assignment)[2].args[2] == :Real
    end

    @testset "_parse_struct_def" begin
        @test _parse_struct_def(struct_name) == (struct_name, [])
        @test _parse_struct_def(sub_typed_params) == (struct_name, [:T1, :(T2<:AbstractVector{T1})])
    end

    @testset "_parse_head" begin
        @test _parse_head(struct_name) == (struct_name, [], :Any)
        @test _parse_head(sub_typed) == (struct_name, Any[:D], :Number)
        @test _parse_head(kitchen_sink) == (struct_name, [:T1, :(T2 <: AbstractVector{T1})], :(AbstractVector{T1}))
    end

    @testset "_strip_super" begin
        @test _strip_super(struct_name) == struct_name
        @test _strip_super(kitchen_sink) == :(MyStruct{T1, T2<:AbstractVector{T1}})
        @test _strip_super([struct_name, sub_typed]) == [struct_name, :(MyStruct{D})]
    end

    @testset "_get_subparams" begin
        @test _get_subparams(struct_name) == []
        @test _get_subparams([:T1, :(T2<:AbstractArray{T1,N}), :(T3<:Complex{T1})]) == Any[:T1, :N, :T1]
    end

    @testset "_get_constructor_params" begin
        @test _get_constructor_params([:T, :(A<:AbstractVector{T})], [:A, :B]) == []
        @test _get_constructor_params([:iip, :T, :(A<:AbstractVector{T})], [:A, :B]) == [:iip]
        @test _get_constructor_params([:iip, :T, :(A<:AbstractVector{T}), :B], [:B]) == [:iip, :A]
    end
end


# # End-to-end tests

# Test setup
@concrete struct Plain end
plain = Plain()

@concrete terse struct PlainTerse end
plain = Plain()

@concrete struct Args
    a
    b
end
args = Args(1+im, "hi")

@concrete terse struct ArgsTerse <: Number
    a
    b
end
args_terse = ArgsTerse(1+im, "hi")

@concrete mutable struct SubtypedMutable <: Number
    a
    b
end
subtyped_mutable = SubtypedMutable(3.0, 4f0)

@concrete struct Partial{A}
    # Hey there, I'm a comment
    a::A

    "And I'm a docsctring"
    b
end
partial = Partial(:yo, 1//2)

@concrete mutable struct ConstructorMutable{iip,C}
    a
    b
    c::C
end
ConstructorMutable(a,b,c) = ConstructorMutable{true}(a,b,eltype(a)(c))
constructor_mutable = ConstructorMutable([1.0+im, 2], 'r', 1.5)
constructor_mutable.b = 'h'

@concrete terse struct TerseSameType{A}
    a::A
    b::A
end
function TerseSameType(a::A, b::B) where {A,B}
    T = promote_type(A, B)
    return TerseSameType{T}(T(a), T(b))
end
terse_same_type = TerseSameType(1+im, 5f0)

@concrete terse struct FullyParameterized{B}
    a::Symbol
    b::B
end
fully_parameterized = FullyParameterized(:sine, sin)

@concrete mutable struct ParameterizedSubtyped{T,N,B<:AbstractArray{T,N}} <: AbstractArray{T,N}
    a
    b::B
    c::T
end
parameterized_subtyped = ParameterizedSubtyped(:🏦, [1, 2, 3], 4)
Base.size(x::ParameterizedSubtyped) = size(x.b)
Base.getindex(x::ParameterizedSubtyped, i...) = x.b[i...]

@concrete terse struct HangingTypeParam{iip}
    a
    b
end
hanging_type_param = HangingTypeParam{true}(1, 2.0)

@concrete terse struct HangingTypeParam2{iip,B}
    a
    b::B
end
hanging_type_param2 = HangingTypeParam2{true}(1, 2.0)


Base.@kwdef @concrete struct KWDef
    a = "ayyy"
    b::Float64 = 4.0
    c<:Real = 3
    d
    e::Float64
    f<:Real
end
kwdef = KWDef(d="hi", e=2.0, f=1//2)


# Run tests
@testset "End-to-end tests" begin
    @test_throws ErrorException args.a = 2+im
    @test_throws MethodError subtyped_mutable.a = "hi"

    @test typeof(partial) |> isconcretetype
    @test typeof(terse_same_type.a) === typeof(terse_same_type.b)
    @test typeof(fully_parameterized.a) |> isconcretetype
    @test eltype(parameterized_subtyped.b) === typeof(parameterized_subtyped.c)
    @test typeof(kwdef) |> isconcretetype

    @test @capture_out(show(stdout, MIME("text/plain"), typeof(fully_parameterized))) == "FullyParameterized{typeof(sin)}"
    @test @capture_out(show(stdout, FullyParameterized)) == "FullyParameterized"
    @test @capture_out(show(stdout, hanging_type_param)) == "HangingTypeParam{true}(1, 2.0)"
    @test @capture_out(show(stdout, MIME("text/plain"), ArgsTerse)) == "ArgsTerse"
end

@testset "Issue #3" begin
    @concrete struct Foo{T<:Real}
        x::T
        y<:Real
        z<:AbstractMatrix{T}
    end

    foo = Foo(1, 1.0, [1, 2]')

    @test typeof(foo) === Foo{Int, Float64, Adjoint{Int, Vector{Int}}}
end

using ConcreteStructs: _parse_head, _parse_struct_def, _parse_line
using ConcreteStructs: _strip_super, _get_subparams, _get_constructor_params
using Test

# Test setup
line_number_node = LineNumberNode(1)
annotated_abstract = :(b::AbstractFloat)
annotated_concrete = :(b::Float64)
struct_name = :(MyStruct)
sub_typed_params = :(MyStruct{T1, T2 <: AbstractVector{T1}})
sub_typed = :(MyStruct{D} <: Number)
kitchen_sink = :(MyStruct{T1, T2 <: AbstractVector{T1}} <: AbstractVector{T1})
plain_assignment = :(a = 1)
annotated_assignment = :(a::Float64 = 2.0)
subtype_annotated_assignment = :(a <: Real = 2.0)

@testset "_parse_line" begin
    @test _parse_line(line_number_node) == (line_number_node, nothing)
    # @test _parse_line(annotated_abstract)[1].args[2] != :AbstractFloat
    # @test _parse_line(annotated_abstract)[2].args[2] == :AbstractFloat
    @test _parse_line(annotated_concrete)[1].args[2] == :Float64
    @test _parse_line(annotated_concrete)[2] === nothing

    parsed_sym = _parse_line(:a)
    @test parsed_sym[1].args[2] == parsed_sym[2]

    @test _parse_line(plain_assignment)[1].head == :(=)
    @test _parse_line(plain_assignment)[1].args[1].args[2] == _parse_line(plain_assignment)[2]
    @test _parse_line(annotated_assignment)[1].head == :(=)
    @test _parse_line(annotated_assignment)[2] === nothing
    @test _parse_line(subtype_annotated_assignment)[1].head == :(=)
    @test _parse_line(subtype_annotated_assignment)[2].args[2] == :Real
end

@testset "_parse_struct_def" begin
    @test _parse_struct_def(struct_name) == (struct_name, [])
    @test _parse_struct_def(sub_typed_params) == (struct_name, [:T1, :(T2 <: AbstractVector{T1})])
end

@testset "_parse_head" begin
    @test _parse_head(struct_name) == (struct_name, [], :Any)
    @test _parse_head(sub_typed) == (struct_name, Any[:D], :Number)
    @test _parse_head(kitchen_sink) == (struct_name, [:T1, :(T2 <: AbstractVector{T1})], :(AbstractVector{T1}))
end

@testset "_strip_super" begin
    @test _strip_super(struct_name) == struct_name
    @test _strip_super(kitchen_sink) == :(MyStruct{T1, T2 <: AbstractVector{T1}})
    @test _strip_super([struct_name, sub_typed]) == [struct_name, :(MyStruct{D})]
end

@testset "_get_subparams" begin
    @test _get_subparams(struct_name) == []
    @test _get_subparams([:T1, :(T2 <: AbstractArray{T1, N}), :(T3 <: Complex{T1})]) == Any[:T1, :N, :T1]
end

@testset "_get_constructor_params" begin
    @test _get_constructor_params([:T, :(A <: AbstractVector{T})], [:A, :B]) == []
    @test _get_constructor_params([:iip, :T, :(A <: AbstractVector{T})], [:A, :B]) == [:iip]
    @test _get_constructor_params([:iip, :T, :(A <: AbstractVector{T}), :B], [:B]) == [:iip, :A]
end

using ConcreteStructs
using LinearAlgebra: Adjoint
using Suppressor
using Test

# Test setup
@concrete struct Plain end
plain = Plain()

@concrete terse struct PlainTerse end
plain_terse = PlainTerse()

"test"
@concrete struct PlainDoc end
plain_doc = PlainDoc()

"test"
@concrete terse struct PlainTerseDoc end
plain_terse_doc = PlainTerseDoc()

@concrete struct Args
    a
    b
end
args = Args(1 + im, "hi")

@concrete terse struct ArgsTerse <: Number
    a
    b
end
args_terse = ArgsTerse(1 + im, "hi")

@concrete mutable struct SubtypedMutable <: Number
    a
    b
end
subtyped_mutable = SubtypedMutable(3.0, 4.0f0)

@concrete struct Partial{A}
    # Hey there, I'm a comment
    a::A

    "And I'm a docsctring"
    b
end
partial = Partial(:yo, 1 // 2)

@concrete mutable struct ConstructorMutable{iip, C}
    a
    b
    c::C
end
ConstructorMutable(a, b, c) = ConstructorMutable{true}(a, b, eltype(a)(c))
constructor_mutable = ConstructorMutable([1.0 + im, 2], 'r', 1.5)
constructor_mutable.b = 'h'

@concrete terse struct TerseSameType{A}
    a::A
    b::A
end
function TerseSameType(a::A, b::B) where {A, B}
    T = promote_type(A, B)
    return TerseSameType{T}(T(a), T(b))
end
terse_same_type = TerseSameType(1 + im, 5.0f0)

@concrete terse struct FullyParameterized{B}
    a::Symbol
    b::B
end
fully_parameterized = FullyParameterized(:sine, sin)

@concrete mutable struct ParameterizedSubtyped{T, N, B <: AbstractArray{T, N}} <: AbstractArray{T, N}
    a
    b::B
    c::T
end
parameterized_subtyped = ParameterizedSubtyped(:🏦, [1, 2, 3], 4)
Base.size(x::ParameterizedSubtyped) = size(x.b)
Base.getindex(x::ParameterizedSubtyped, i...) = x.b[i...]

@concrete terse struct HangingTypeParam{iip}
    a
    b
end
hanging_type_param = HangingTypeParam{true}(1, 2.0)

@concrete terse struct HangingTypeParam2{iip, B}
    a
    b::B
end
hanging_type_param2 = HangingTypeParam2{true}(1, 2.0)


Base.@kwdef @concrete struct KWDef
    a = "ayyy"
    b::Float64 = 4.0
    c <: Real = 3
    d
    e::Float64
    f <: Real
end
kwdef = KWDef(d = "hi", e = 2.0, f = 1 // 2)


# Run tests
@test_throws ErrorException args.a = 2 + im
@test_throws MethodError subtyped_mutable.a = "hi"

@test typeof(partial) |> isconcretetype
@test typeof(terse_same_type.a) === typeof(terse_same_type.b)
@test typeof(fully_parameterized.a) |> isconcretetype
@test eltype(parameterized_subtyped.b) === typeof(parameterized_subtyped.c)
@test typeof(kwdef) |> isconcretetype

@test @capture_out(show(stdout, MIME("text/plain"), typeof(fully_parameterized))) == "FullyParameterized{typeof(sin)}"
@test @capture_out(show(stdout, FullyParameterized)) == "FullyParameterized"
@test @capture_out(show(stdout, hanging_type_param)) == "HangingTypeParam{true}(1, 2.0)"
@test @capture_out(show(stdout, MIME("text/plain"), ArgsTerse)) == "ArgsTerse"

using Documenter
using Documenter.Remotes: GitHub
using ConcreteStructs

DocMeta.setdocmeta!(ConcreteStructs, :DocTestSetup, :(using ConcreteStructs); recursive = true)

makedocs(
    modules = [ConcreteStructs],
    sitename = "ConcreteStructs.jl",
    pages = [
        "Home" => "index.md",
        "Walkthrough" => "walkthrough.md",
        "API" => "api.md",
    ],
    format = Documenter.HTML(
        canonical = "https://jonniedie.github.io/ConcreteStructs.jl/stable",
        prettyurls = get(ENV, "CI", nothing) == "true",
    ),
    repo = GitHub("jonniedie/ConcreteStructs.jl"),
    authors = "Jonnie Diegelman",
    doctest = true,
    checkdocs = :exports,
)

# Documenter can also automatically deploy documentation to gh-pages.
# See "Hosting Documentation" and deploydocs() in the Documenter manual
# for more information.
deploydocs(
    repo = "github.com/jonniedie/ConcreteStructs.jl.git"
)

using ConcreteStructs
using Test

# `@concrete` applied to something that is neither a struct definition nor a
# macrocall wrapping one reaches `_find_struct_def`'s fallthrough, which must
# raise a clear `ErrorException` (previously a `nerror` typo made this throw
# an `UndefVarError` instead).
@test_throws "Invalid usage of @concrete." @macroexpand(@concrete x = 1)

using ConcreteStructs
using Test

# this has been working for a while already
Base.@kwdef @concrete struct Foo2{T <: Real}
    x::T = 1.0
    y = true
    z = 42
end

foo = Foo2()
@test typeof(foo) === Foo2{Float64, Bool, Int64}

# this is new
@concrete Base.@kwdef struct Foo3{T <: Real}
    x::T = 1.0
    y = true
    z = 42
end

foo = Foo3()
@test typeof(foo) === Foo3{Float64, Bool, Int64}

foo = Foo3(z = [1, 2, 3])
@test typeof(foo) === Foo3{Float64, Bool, Vector{Int64}}

# terse test case, unfortunately doesn't work the other way around. But also never did.
@concrete terse Base.@kwdef struct TerseKWDef
    a = 1.0
    b = true
end
terse_kw_def = TerseKWDef(b = false)
@test typeof(terse_kw_def) === TerseKWDef{Float64, Bool}

using ConcreteStructs
using LinearAlgebra: Adjoint
using Test

@concrete struct Foo{T <: Real}
    x::T
    y <: Real
    z <: AbstractMatrix{T}
end

foo = Foo(1, 1.0, [1, 2]')

@test typeof(foo) === Foo{Int, Float64, Adjoint{Int, Vector{Int}}}

```@meta
DocTestSetup = :(using ConcreteStructs)
```

# Walkthrough
The `@concrete` macro can be tacked onto any `struct` definition that isn't already concretely-typed. That's kinda all there is to it, but let's walk through some examples anyway to get a feel for it.

In this example, no type parameters are given, so they will be filled in automatically:

```jldoctest
julia> @concrete struct Whatever
           a
           b
       end

julia> complex_whatever = Whatever(1+im, "It's pretty complex")
Whatever{Complex{Int64}, String}(1 + 1im, "It's pretty complex")
```

But maybe we don't want to show the type parameters, since we never cared much about them in the first place. If we want our `struct` to print a little more succinctly, we can add the `terse` keyword. Now it will print as if we never added the `@concrete` macro.

```jldoctest prettier-whatever
julia> @concrete terse struct PrettierWhatever
           a
           b
       end

julia> pretty_whatever = PrettierWhatever(1+im, "It's still pretty complex")
PrettierWhatever{}(1 + 1im, "It's still pretty complex")
```
The full type information is still available for inspection with the `typeof` function, though.
```jldoctest prettier-whatever
julia> typeof(pretty_whatever)
PrettierWhatever{Complex{Int64},String}
```

More complicated type parameterizations are possible as well. Take this example of an array with two metadata fields attached. The type parameters for the `array` field are provided but the `name` field's type is left open. The `@concrete` macro will respect the given type parameters and concretely parameterize the `name` field.

```jldoctest
julia> @concrete struct MetaArray{T,N,A<:AbstractArray{T,N}} <: AbstractArray{T,N}
           array::A
           name
       end

julia> Base.size(x::MetaArray) = size(x.array);

julia> Base.getindex(x::MetaArray, i...) = getindex(x.array[i...]);

julia> abed = MetaArray([8,10,2,5], "Abed")
4-element MetaArray{Int64, 1, Vector{Int64}, String}:
  8
 10
  2
  5
```

We can also have type parameters that don't correspond to any field. In this example, the `BananaStand` type is parameterized by the boolean value `has_money`. 

```jldoctest banana-stand
julia> @concrete terse mutable struct BananaStand{has_money}
           employees
           manager
       end
```

In this case, the constructor must be given with the `has_money` parameter, just like it would need to be if we weren't using the `@concrete` macro. Since the `terse` keyword was give, the type will print exactly as it's specified: with the `has_money` parameterization but no field parameterizations.

```jldoctest banana-stand
julia> the_banana_stand = BananaStand{true}(["Maeby", "Annyong"], "George Michael")
BananaStand{true}(["Maeby", "Annyong"], "George Michael")

julia> typeof(the_banana_stand)
BananaStand{true,Vector{String},String}
```

# ConcreteStructs.jl

ConcreteStructs exports the macro `@concrete` that will add type parameters to your struct for any field where type parameters aren’t given.

Simply add the `@concrete` macro before any valid `struct` definition and it should automagically make all of your non-type-annotated fields type-annotated. If you don't like the verbose type printing 
